<?php
namespace Claromentis\Core\ORM\Behaviors;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] ?: array()) + array("_b255ebafd5b8bb451" . "10cd2db0604fa44" => base64_decode("bWV" . "0YW" . "Rhd" . "GE="), "_7f628626dd1d55c7" . "1b1fc0932ffd1d2c" => base64_decode("aXNfYXJyYX" . "k="), "_d5aab080ef" . "90d0e0aeec9" . "b29c03836f2" => base64_decode("TWV0YWRhdGEgbXVzdCBiZSBhbiBhcnJheSBv" . "ZiBtZXRhZGF0YSB2YWx1ZXMgb3IgYW4gaW5z" . "dGFuY2Ugb2Yg"), "_c006f837e2824506391e308" . "8e0b02cea" => base64_decode("IG9yIA=" . "="));
use Analogue\ORM\EntityCollection;
use Analogue\ORM\Mappable;
use Illuminate\Support\Collection;
use ProxyManager\Proxy\ProxyInterface;
use Claromentis\Core\ORM\Entity\Metadata as MetadataEntity;






















trait Metadata
{
    
    
    
    
    
    
    protected $metadata;
    
    
    
    
    
    
    public abstract function getMetadataAggregation() : int;
    
    
    
    
    
    
    public function getMetadataObjectId() : int
    {
        return $this->id;
    }
    
    
    
    
    
    
    public function getMetadataSetId() : int
    {
        return 0;
    }
    
    
    
    
    
    
    
    
    
    
    public function getMetadataAttribute($elements) : MetadataEntity
    {
        
        
        if (!$this->metadata) {
            $aggregation = $this->getMetadataAggregation();
            $object_id = $this->getMetadataObjectId();
            $set_id = $this->getMetadataSetId();
            $this->metadata = new MetadataEntity($this, $aggregation, $object_id, $set_id);
            $this->metadata->elements = $elements ?: new EntityCollection();
        }
        return $this->metadata;
    }
    
    
    
    
    
    
    
    
    
    public function setMetadataAttribute($metadata)
    {
        if (!$metadata instanceof MetadataEntity && !$metadata instanceof Collection && !$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_7f628626dd1d55c71b1" . "fc0932ffd1d2c"]($metadata)) {
            throw new \InvalidArgumentException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_d5aab080ef90d0e0aeec9b29c0" . "3836f2"] . Collection::class . $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_c006f837e2824506391e3088e0b02ce" . "a"] . MetadataEntity::class);
        }
        
        
        if ($metadata instanceof MetadataEntity) {
            $this->attributes[$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_b255ebaf" . "d5b8bb451" . "10cd2db06" . "04fa44"]] = $metadata->getElements()->flatten()->filter();
        }
        if ($metadata instanceof Collection) {
            $this->attributes[$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_b255ebafd5b8bb45110cd2db0604" . "fa44"]] = $metadata->flatten()->filter();
        }
        
        
        if ($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_7f628626dd1d55c71b1fc0932ffd1d" . "2c"]($metadata)) {
            $metadataEntity = $this->getMetadataAttribute(null);
            $metadataEntity->setValues($metadata);
        }
    }
}